Redmine - Defect #38250

config/settings.yml not closed in Setting.load_available_settings
2023-02-06 12:42 - Thomas L&ber
Assignee: Go MAEDA % Done: 0%
Target version: 5.1.0

Resolution: Fixed Affected version: 5.0.4
Description

The file config/settings.yml is not closed after it is read in Setting.load_available_settings.

This can cause problems during development, for example when changing Git branches while the Rails server is running (error:
unable to unlink old ‘config/settings.yml).

The solution is to pass a block to File.open, as it will automatically close the file after the block is executed.

def self.load_available_settings
File.open("#{Rails.root}/config/settings.yml") do |f|
YAML.load (f) .each do |name, options|
define_setting name, options
end
end
end

Associated revisions

Revision 22099 - 2023-02-06 15:08 - Go MAEDA

Fix config/settings.yml not closed in Setting.load_available_settings (#38250).

Patch by Thomas Léber.

Revision 22101 - 2023-02-13 15:35 - Go MAEDA
Refactor code to use YAML.load_file instead of explicitly opening the file (#38250).

History

#1 - 2023-02-06 14:55 - Go MAEDA
- Subject changed from settings.yml not closed to config/settings.yml not closed in Setting.load_available_settings
- Status changed from New to Confirmed

- Target version set to 4.2.10

#2 - 2023-02-06 15:08 - Go MAEDA
- Status changed from Confirmed to Resolved
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix. Thank you for reporting and fixing the issue.

#3 - 2023-02-07 21:26 - Holger Just

Rather than explicitly opening the file ourselves, we may also use YAML.load file.

#4 - 2023-02-08 14:24 - Thomas Loéber

Until today, | didn't know that this method even existed. You never stop learning :-)

Here is a new patch using YAML.load_file:
https://ruby-doc.org/stdlib-3.1.0/libdoc/psych/rdoc/Psych.html#method-c-load_file

-—— a/app/models/setting.rb
+++ b/app/models/setting.rb
@@ -320,7 +320,7 Q@

end

def self.load_available_settings

f YAML: :load(File.open ("#{Rails.root}/config/settings.yml")) .each do |name, options|
+ YAML.load_file(Rails.root + "config/settings.yml").each do |name, options|
define_setting name, options
end
end

#5 - 2023-02-13 15:35 - Go MAEDA

Holger Just wrote:

Rather than explicitly opening the file ourselves, we may also use YAML.load file.

Thank you, updated the code in r22101.

#6 - 2023-02-15 10:09 - Go MAEDA
- Target version changed from 4.2.10 to 5.1.0

#7 - 2023-02-15 10:10 - Go MAEDA

- Status changed from Resolved to Closed
